unit U_ScrabbleSearch2;
{Copyright  2013, Gary Darby,  www.DelphiForFun.org
 This program may be used or modified for any non-commercial purpose
 so long as this original notice remains in place.
 All other rights are reserved
 }

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  shellAPI, StdCtrls, ComCtrls, Dialogs, ExtCtrls, Graphics, UCombov2, Spin,
  Grids, strUtils, dffutils;

type
  TForm1 = class(TForm)
    StaticText1: TStaticText;
    Panel1: TPanel;
    Memo1: TMemo;
    SearchBtn: TButton;
    Memo2: TMemo;
    GroupBox1: TGroupBox;
    Player1Btn: TRadioButton;
    Player2btn: TRadioButton;
    Player3Btn: TRadioButton;
    Player4Btn: TRadioButton;
    RadioButton5: TRadioButton;
    GroupBox2: TGroupBox;
    MyLetters: TEdit;
    Memo3: TMemo;
    Memo4: TMemo;
    Memo5: TMemo;
    TileGrid: TStringGrid;
    ResetBtn: TButton;
    Memo6: TMemo;
    NbrPlayersGrp: TRadioGroup;
    MyGrid: TStringGrid;
    WaitBox: TGroupBox;
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    Timer1: TTimer;
    procedure StaticText1Click(Sender: TObject);
    procedure SearchBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RadioButtonClick(Sender: TObject);
    procedure MyLettersKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo3KeyPress(Sender: TObject; var Key: Char);
    procedure TileGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ResetBtnClick(Sender: TObject);
    procedure MyLettersExit(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Memo2Click(Sender: TObject);
    procedure NbrPlayersGrpClick(Sender: TObject);
    procedure MyLettersDblClick(Sender: TObject);
    procedure MyGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Timer1Timer(Sender: TObject);
    procedure TileGridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  public
    playerindex, previndex:integer;
    letters: array[0..3,0..6] of char;
    wordlist, foundwordslist:TStringlist;
    tilecount, AvailTileCount:integer;
    lettersremoved:boolean;
    nbrplayers:integer;
    players:array[0..3] of TRadioButton;
    stoptime:Ttime;
    procedure Searchwords(key:string; var before,after:integer; var addletter:char);
    procedure LoadboardGrid;
    procedure DrawTiles;
    procedure ShowMytiles(s:string);
    procedure StartTimer;
    procedure StopTimer;
end;

var
  Form1: TForm1;

implementation
uses math, mathslib ;

{$R *.DFM}

type
  TV=(_,A,B);
var
  Values:Array ['@'..'Z'] of integer
          =(0,1,3,3,2,1,4,2,4,1,8,5,1,3,1,1,3,10,1,1,1,1,4,4,8,4,10);
  Counts:Array ['@'..'Z'] of integer
          =(2,9,2,2,4,12,2,3,2,9,1,1,4,2,6,8,2,1,6,4,6,4,2,2,1,2,1);
  //blankval:integer=0;
  //blankcount:integer=2;
  TileArray: Array of char;

(*
English-language editions of Scrabble contain 100 letter tiles, in the following distribution:
0 points: Blank tiles x2
1 point: E 12, A 9, I 9, O 8, N 6, R 6, T 6, L 4, S 4, U 4
2 points: D 4, G 3
3 points: B 2, C 2, M 2, P 2
4 points: F 2, H 2, V 2, W 2, Y 2
5 points: K 1
8 points: J 1, X 1
10 points: Q 1, Z 1
*)

{*********** Shuffle ***********}
procedure shuffle(var deck:array of integer);
{Shuffle = randomly rearrange  an array of integers}
var  i,n,temp:integer;
begin
  i:= high(deck); {starting from the end of the deck}
  while i>0 do
  begin
    n:=random(i+1);  {pick a random card, "n",  at or below this card}
    temp:=deck[i];   {and swap card "i" with card "n"}
    deck[i]:=deck[n];
    deck[n]:=temp;
    dec(i);       {move to the next prior card}
  end;            {and loop}
end;

{******** StartTimer ********}
procedure TForm1.StartTimer;
begin
  stoptime:=time+180/secsperday;     {set 3 minute timer}
  Label1.Caption:=formatDateTime('n:ss',180/secsperday);
  label1.Visible:=true;
  timer1.Enabled:=true;
end;

{********* StopTimer ********}
procedure TForm1.StopTimer;
begin
  timer1.enabled:=false;
  label1.visible:=false;
end;

{************** FormCreate ************}
procedure TForm1.FormCreate(Sender: TObject);
var
  i:integer;
  c:char;
begin
  randomize;
  WordList:=TStringlist.create;
  Wordlist.loadfromfile(extractfilepath(application.exename)+'Allwords.txt');
  wordlist.Sorted:=true;
  foundwordslist:=TStringlist.create;
  //tilecount:=0;
  setlength(TileArray,100);
  (*
  for i:= 1 to blankcount do
  begin
    TileArray[tilecount]:='_';
    inc(tilecount);
  end;
  *)
  tilecount:=0;
  for c:= low(counts) to high(counts) do
  begin
    for i:=0 to counts[c]-1 do
    begin
      if c=low(counts) then TileArray[tilecount]:=' '
      else TileArray[tilecount]:=c;
      inc(tilecount);
    end;
  end;
  if tilecount<>100 then
  begin
    showmessage('Tile count error - call Grandpa');
    halt;
  end;
  resetbtnclick(sender);
  AvailTilecount:=tilecount;
    players[0]:=Player1Btn;
  Players[1]:=Player2Btn;
  Players[2]:=Player3Btn;
  Players[3]:=Player4Btn;

  NbrPlayers:=2;
  NbrPlayersgrp.itemindex:=1;  {Set default to 2 players}
  LoadBoardGrid;
  
  StopTimer;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  playerindex:=0;
  //drawtiles;
  previndex:=-1;
  playerindex:=-1;
  Player1Btn.checked:=true;

end;

{*************** LoadBoardGrid **************}
Procedure TForm1.loadBoardGrid;
var
  i,j,r,c:integer;
  deck:array[0..99] of integer;
begin
  for i:=0 to nbrplayers-1  do for j:=0 to 6 do letters[i,j]:='.';
  playerindex:=0;
  previndex:=-1;
  MyLetters.text:='......';
  for i:=0 to 6 do Mygrid.Cells[i,0]:='.';
  for i:=0 to 99 do deck[i]:=i;
  shuffle(deck);
  for c:=0 to 9 do for r:=0 to 9 do
  with tilegrid do cells[c,r]:=tileArray[10*c+r];
  availtilecount:=100;
end;

{*********** SearchBtnClick *************}
 procedure TForm1.SearchBtnClick(Sender: TObject) ;
 Var
    i:integer;
    before,after:integer;
    addletter:char;
    key:string;

    function ValidKey(key:string; var before,after:integer; var addletter:char):boolean;
    begin

      if ((length(key)<>3) or (not (key[1] in ['0'..'9']))
      or (not (key[2] in ['A'..'Z'])) or (not (key[3] in ['0'..'9'])))
      and (key<>'000')
      then
      begin
        before:=0;
        after:=0;
        result:=false;
        if length(key)>0 then showmessage('Invalid "Available Targets" key: '+ key);
      end
      else
      begin
        result:=true;
        before:=strtoint(key[1]);
        addletter:=upcase(key[2]);
        if addletter='0' then addletter:=' ';
        after:=strtoInt(key[3]);
      end;
    end;

 begin  {SearchBtnCliock}
   If playerindex<0 then showmessage('Select a player first')
   else
   begin;
     foundwordslist.clear;
     memo2.clear;
     lettersremoved:=false;
     with memo3 do
     for i:=0 to lines.count-1 do
     begin
       key:=trim(lines[i]);
       if validkey(key, before,after, addletter)
       then
       begin
         memo2.Lines.Add('== '+key+' ==');
         searchwords(key,before,after,addletter);
       end;
     end;
   end;
   scrolltotop(memo2);
 end;

 {*************** SearchWords ************}
 procedure TForm1.Searchwords(key:string; var before,after:integer; var addletter:char);
 var
   i,j,len,index:integer;
   maxlen:integer;
   w,baseword:string;
   b1,b2:integer;
   p1,p2:char;
   stop:integer;

   {------------- AdjustWord ------------}
   function adjustword(b1,b2:integer; var p1,p2:char; var w:string):boolean;
   begin
     if (p1>'Z') or ((b2>0) and (p2>'Z')) then result:=false
     else
     begin
       result:=true;
       if (b2>0) and (p2<='Z') then
       begin
         if w[b1]=' ' then
         begin
           w[b1]:=p1;
           p1:=succ(p1);
         end;

         w[b2]:=p2;
         p2:=succ(p2);
       end
       else  if (p1<='Z') then
       begin
         w[b1]:=p1;
         p1:=succ(p1);
         if b2>0 then p2:='A';
       end;
     end;
   end;

   {----------- CheckWord --------}
   procedure checkword(w:string);
   var
     v,k:integer;
   begin
     if length(w)<2 then exit;
     if wordlist.find(w, index) then
     begin
       if foundwordslist.indexof(w)<0 then
       begin {new entry found}
         foundwordslist.add(w);
         v:=values[w[1]];
         for k:=2 to length(w) do inc(v,values[w[k]]);
         memo2.lines.add(format('%s (%d)',[w,v]));
       end;
     end;
   end;

 begin  {SearchWords}
   maxlen:=length(MyLetters.text);
   with combos do
   begin
     for i:= maxlen downto 2 do
     begin
       setup(i,maxlen,permutations);
       while getnext do
       begin
         baseword:='';
         for j:=1 to i do baseword:=baseword+MyLetters.text[selected[j]];  {get the permuted letters}
         baseword:=stringreplace(baseword,' ',' ',[rfReplaceAll]);
         len:=i;
         if key<>'000' then
         begin
           inc(len);
           stop:=len;
          end
          else stop:=1;
         for j:=1 to stop do
         begin
           w:=baseword;
           if key<>'000' then insert(addletter,w,j); {inset the intersecting letter in i+1 postiions}
           If (key='000') or ((j<=before+1) and ((len-j)<=after)) then
           begin
             {if word happens to contain a ' ' (blank), we need to try all 26
              letters in that position}
             b1:=pos(' ',w);
             if b1>0 then
             begin
               b2:=posex(' ',w,b1+1);  {Oh no, two blanks?}
               p1:='A'; p2:='A';
               while adjustword(b1,b2,p1,p2,w) do  checkword(w);
             end
             else checkword(w);
           end;
         end;
       end;
     end;
   end;
 end;


{************* RadioBtnClick *************}
procedure TForm1.RadioButtonClick(Sender: TObject);
var
  i:integer;
  w:string;
begin
  StopTimer;
  previndex:=playerindex;
  playerindex:=TRadiobutton(sender).tag;
  memo2.clear;
  Label1.Visible:=true;
  if previndex>=0  {save the previous user's tiles}
  then for i:=0 to 6 do letters[previndex,i]:=MyLetters.text[i+1];
  if playerindex< 0 then {Select next player buton clicked}
  begin
    MyLetters.Text:='.......';
    for i:=0 to 6 do mygrid.Cells[i,0]:='.';

    WaitBox.visible:=true;
    application.ProcessMessages;
    for i:=1 to 10 do
    begin
      sleep(1000);
      progressbar1.position:=10-i;
    end;
    waitbox.Visible:=false;
    playerindex:=(previndex+1) mod (nbrplayers) ;
    players[playerindex].Checked:=true;
  end;

  label1.Caption:=formatdatetime('n:ss',180/secsperday);
  if letters[playerindex,0]='.' then  {first  entry for this player}
  begin
    myletters.text:='.......';
    for i:=0 to 6 do mygrid.Cells[i,0]:='.';
  end
  else starttimer;
  w:=letters[playerindex,0];
  for i:=1 to 6 do w:=w+letters[playerindex,i];
  MyLetters.text:=w;
  ShowMyTiles(w);
  for i:=0 to 6 do  mygrid.Cells[i,0]:=letters[playerindex,i];
  MyLetters.SetFocus;
end;

{**************** Timer1Timer ************}
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if stoptime-time>=0 then label1.Caption:=formatdatetime('n:ss',stoptime-time)
  else
  begin
    StopTimer;
    //timer1.enabled:=false;;
    beep;
    //label1.Visible:=false;
  end;
end;

{********** ValidKey ************}
function validkey(key:word):boolean;
  begin  {Test key pressed}
    result := chr(key) in [' ','A'..'Z'];
  end;

function ValidWord(s:string):boolean;
var i:integer;
begin  {Check that word has only letters or blank tiles}
  result:=false;
  for i:=1 to length(s) do if not (s[i] in[' ','A'..'Z']) then exit;
  result:=true;
end;

{********* DrawTiles *************}
procedure TForm1.DrawTiles;
 var
   i,n,count:integer;
   c,r:integer;
   s:string;
begin

  s:=myletters.Text;
  {remove invalid characters}
  for i:=length(s) downto 1 do if not(s[i] in [' ','A'..'Z']) then delete(s,i,1);
  for i:=length(s) to 6 do
  begin
    n:=random(AvailTileCount)+1;
    {Find and select the nth random remaining tile}
    count:=0;
    with tilegrid do
    for c:=0 to 9 do
    for r:=0 to 9 do
    if cells[c,r]<>'0' then  {'0' is the "already drawn" flag}
    begin
      inc(count);
      if count=n then
      begin
        s:=s+cells[c,r];
        cells[c,r]:='0';
        dec(AvailTilecount);
      end;
    end;
  end;
  MyLetters.Text:=s;
  for i:=0 to 6 do mygrid.Cells[i,0]:=MyLetters.Text[i+1];
   myLetters.setfocus;
end;


{************ MyLettersKeyUp ***********}
procedure TForm1.MyLettersKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);

  procedure deleteletter(k:integer);
  var s:string;
  begin
    s:=myletters.text;
    delete(s,k,1);
    myletters.text:=s;
  end;

begin

  if validKey(key) then
  with myletters do
  begin
    if (length(text)>7) then
    begin
      if (messagedlg('Adding this will delete the final tile '+ text[8] +'. Proceed?',
              mtconfirmation, [mbyes, mbno],0) =mrYes)
      then DeleteLetter(8)
      else deleteLetter(selstart);
    end;
    ShowMytiles(text);
  end
  else deleteletter(MyLetters.selstart);
  if not timer1.Enabled then Starttimer;
end;

{*********** MyLettersDblClick ***********}
procedure TForm1.MyLettersDblClick(Sender: TObject);
begin
  DrawTiles;
  If not timer1.enabled then starttimer;
end;

{********** Memo3KeyPress ************}
procedure TForm1.Memo3KeyPress(Sender: TObject; var Key: Char);
begin
  key:=upcase(key);
end;

{************* TileGridDrawCell **********}
procedure TForm1.TileGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
{Draw the available tiles from to 10 x 10 total tile pool}
begin
  with tilegrid, canvas do
  begin
    brush.color:=color;
    rectangle(rect);
    if cells[acol,arow][1] in [' ','A'..'Z'] then
    begin
      brush.Color:=clblack;
      with rect do rectangle(left+2, top+2, right-2, bottom -2);
    end;
  end;
end;

{********** ResetBtnClick **********}
procedure TForm1.ResetBtnClick(Sender: TObject);
begin
  LoadBoardGrid;
  memo2.clear;
end;



procedure TForm1.MyLettersExit(Sender: TObject);
begin

end;

{*********** ShowMyTiles *************}
procedure TForm1.ShowMyTiles(s:string);
var
  i:integer;
begin
  for i:=0 to 6 do
  if i<length(s) then MyGrid.cells[i,0]:=s[i+1]
  else Mygrid.cells[i,0]:='0';
end;

{************ Memo2Click ************}
procedure TForm1.Memo2Click(Sender: TObject);
var
  i,k,n:integer;
  s,line:string;
  ch:char;
  blankcount:integer;
begin
  if lettersremoved then
  begin
    showmessage('Word has already been selected and tiles removed from your set!');
    exit;
  end;
  n:=memolineclicked(memo2);
  line:=memo2.lines[n];
  i:=pos('(',line);
  if i>0 then delete(line,i, 5);
  line:=trim(line);
  if validword(line) then
  with memo2 do
  begin
    repeat dec(n)
    until (n<0) or (lines[n][1]='=');
    if n>=0 then
    begin
      s:=myLetters.Text;
      ch:=lines[n][5];
      line:=stringreplace(line,ch,'',[]); {delete the interseting letter}
      blankcount:=0;
      for n:=length(line) downto 1 do
      begin
        if pos(line[n],s)=0 then inc(blankcount);
        s:=stringreplace(s,line[n],'',[]);
      end;
      if blankcount>0 then
      begin  {we found letters in the result word that arfe not in the input tile set
              so we had better have that many blank tiles that were used and should be deleted}
        while (blankcount > 0) do
        begin
          k:=pos(' ',s);
          if k>0 then
          begin
            delete(s,k,1);
            dec(blankcount);
          end
          else
          begin
            showmessage('Error: Letter in word w/o blank to cover it');
            break;
          end;
        end;
      end;
    end;
    with myletters do
    begin
      SetFocus;
      text:=s;
      showMytiles(s);
      selstart:=0;
      sellength:=0;
      lettersremoved:=true;
    end;
  end;
end;

{************ NbrPlayersGrpClick **********}
procedure TForm1.NbrPlayersGrpClick(Sender: TObject);
begin
  with tradiogroup(sender) do
  begin
    if itemindex>0 then player2btn.enabled:=true else player2btn.enabled:=false;
    if itemindex>1 then player3btn.enabled:=true else player3btn.enabled:=false;
    if itemindex>2 then player4btn.enabled:=true else player4btn.enabled:=false;
  end;
  ResetBtnClick(Sender);
end;

{************ MyGridDawCell ***********}
procedure TForm1.MyGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
{OnDrawCell exit to redraw a user's tile}
  var
   ch:char;
   h,val:integer;
begin
  with MyGrid, canvas do
  begin
    rectangle(rect);
    ch:= cells[acol,arow][1];
    if ch in [' ','A'..'Z'] then
    with rect do
    begin
      brush.color:=clblack;
      font.Color:=clyellow;
      rectangle(left+1, top+1, right-1, bottom-1);
      Font.Size:=12;
      textout(left+6,top+8,ch);
      font.Size:=8;
      if ch=' ' then val:=0 else val:=values[ch];
      if val>=10 then h:=16 else h:=10;  {horizontal offset for tile value}
      textout(right-h,top+2, inttostr(val));
    end;
  end;
end;

{************* TileGridMouseUp *************}
procedure TForm1.TileGridMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{  Add a clicked tile in the tile grid to MyLetters}
var
  acol,arow:integer;
  ch:char;
begin
   TileGrid.mousetocell(x,y,Acol,arow);
   ch:=Tilegrid.cells[acol,arow][1];
   if ch in [' ','A'..'Z'] then
   with myletters do
   if length(text)<7 then
   begin
     text:=text+ch;
     showMyTiles(text);
     tilegrid.cells[acol,arow]:='0';
   end;
end;

procedure TForm1.StaticText1Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'http://www.delphiforfun.org/',
  nil, nil, SW_SHOWNORMAL) ;
end;



end.
